Package org.eclipse.cdt.core.dom.ast

# Interface IASTLiteralExpression

All Superinterfaces:
  `IASTExpression`, `IASTInitializerClause`, `IASTNode`

All Known Subinterfaces:
  `ICPPASTLiteralExpression`

public interface IASTLiteralExpression extends IASTExpression
This expression represents a literal in the program.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`lk_char_constant`
A character literal e.g.
`static final int`
`lk_false`
`lk_false` represents the '`false`' keyword.
`static final int`
`lk_float_constant`
A floating point literal e.g.
`static final int`
`lk_integer_constant`
An integer literal e.g.
`static final int`
`lk_nullptr`
`lk_nullptr` represents the '`nullptr`' keyword.
`static final int`
`lk_string_literal`
A string literal e.g.
`static final int`
`lk_this`
`lk_this` represents the '`this`' keyword for C++ only.
`static final int`
`lk_true`
`lk_true` represents the '`true`' keyword.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`IASTLiteralExpression`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`IASTLiteralExpression`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`int`
`getKind()`
Returns the kind of the literal expression kind, which can be one of the `lk_*` constants defined above.
`char[]`
`getValue()`
Returns the value of the literal as char-array.
`void`
`setKind(int value)`
Sets the kind of the literal expression.
`void`
`setValue(char[] value)`
Sets the value for the expression.
`void`
`setValue(String value)`
Deprecated.
Replaced by `setValue(char[])`.
`String`
`toString()`
Returns the value of the literal as string.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

## Field Details

### lk_integer_constant

static final int lk_integer_constant
An integer literal e.g. `5`

See Also:
  - Constant Field Values

### lk_float_constant

static final int lk_float_constant
A floating point literal e.g. `6.0`

See Also:
  - Constant Field Values

### lk_char_constant

static final int lk_char_constant
A character literal e.g. `'a'`

See Also:
  - Constant Field Values

### lk_string_literal

static final int lk_string_literal
A string literal e.g. `"a literal"`

See Also:
  - Constant Field Values

### lk_this

static final int lk_this
`lk_this` represents the '`this`' keyword for C++ only.

Since:
  5.1
See Also:
  - Constant Field Values

### lk_true

static final int lk_true
`lk_true` represents the '`true`' keyword.

Since:
  5.1
See Also:
  - Constant Field Values

### lk_false

static final int lk_false
`lk_false` represents the '`false`' keyword.

Since:
  5.1
See Also:
  - Constant Field Values

### lk_nullptr

static final int lk_nullptr
`lk_nullptr` represents the '`nullptr`' keyword.

Since:
  5.4
See Also:
  - Constant Field Values

## Method Details

### getKind

int getKind()
Returns the kind of the literal expression kind, which can be one of the `lk_*` constants defined above.

### getValue

char[] getValue()
Returns the value of the literal as char-array.

Since:
  5.1

### toString

String toString()
Returns the value of the literal as string.

Overrides:
  `toString` in class `Object`
Since:
  5.1

### setKind

void setKind(int value)
Sets the kind of the literal expression.

### setValue

void setValue(char[] value)
Sets the value for the expression.

Since:
  5.1

### copy

IASTLiteralExpression copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

### copy

IASTLiteralExpression copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

### setValue

@Deprecated void setValue(String value)
Deprecated.
Replaced by `setValue(char[])`.

Restriction:
  This method is not intended to be referenced by clients.